from netgen.csg import *

geo = CSGeometry()
cube = OrthoBrick(Pnt(-5700,-5700,0), Pnt(7100,7100,6300))


cyl1_in=Cylinder(Pnt(700,700,0), Pnt(700,700,200),490)
cyl1=Cylinder(Pnt(700,700,0), Pnt(700,700,200),500)
cyl2 = Cylinder(Pnt(700,700,0), Pnt(700,700,200),505)
cyl3 = Cylinder(Pnt(700,700,0), Pnt(700,700,200),515)
outside = Cylinder(Pnt(700,700,0), Pnt(700,700,200),1000)

dom1=cyl1 * cube - cyl1_in
dom2=cyl2 * cube - cyl1
dom3=cyl3 * cube - cyl2
outside = outside * cube - cyl3

geo.Add(dom1,maxh=100)
geo.Add(dom2,maxh=100)
geo.Add(dom3,maxh=100)
geo.Add(outside)

n =10
slices1x = [i/n for i in range(1,n)]

slices2 = [i/2 for i in range(1,2)]

geo.CloseSurfaces(cyl1,cyl1_in,slices1x)
geo.CloseSurfaces(cyl1,cyl2,slices2)
geo.CloseSurfaces(cyl2,cyl3,slices1x)


geo.SetBoundingBox(Pnt (-12000, -12000, -12000), Pnt(12000, 12000, 12000))

ngmesh = geo.GenerateMesh(maxh=700)
ZRefinement(ngmesh, geo)

from ngsolve import *
mesh = Mesh(ngmesh)
Draw(mesh)
